## Prerequisites

This image needs access to the files generated by autosubmit

## Build

To build the image you can execute `./build.sh`, or:

```bash
docker build -t autosubmit-api .
```

## Run

### Default run

If you followed the normal installation path of autosubmit (creating the autosubmit directory `~/autosubmit`). You can run `./run.sh`.

Else, you can set which are the directories that holds your DDBB files and experiment directories like this:

```bash
docker run --name autosubmit-api-container \
    --rm -d -p 8099:8000 \
    -v ${YOUR_DB_PATH}:/app/autosubmit/database \
    -v ${YOUR_EXPERIMENTS_PATH}:/app/autosubmit/experiments \
    autosubmit-api
```

This will expose a default API instance on port `8099`.

### Custom run (Recommended)

Alternatively, you can run the command `autosubmit_api` with custom parameters by adding additional arguments like this:

```bash
# Run with 6 workers, log level DEBUG, and map from port 9000
docker run --name autosubmit-api-container \
    --rm -p 8099:9000 \
    -v ${YOUR_DB_PATH}:/app/autosubmit/database \
    -v ${YOUR_EXPERIMENTS_PATH}:/app/autosubmit/experiments \
    autosubmit-api start -w=6 --log-level=DEBUG -b=0.0.0.0:9000
```

> **IMPORTANT** Always use the `-b` flag with `0.0.0.0` as the host to properly map the container API port


## Env Variables Configuration

The `autosubmit_api` use env variables to configure some features like auth.

Here is an example:

```bash
docker run --name autosubmit-api-container \
    --rm -p 8099:9000 \
    -v ${YOUR_DB_PATH}:/app/autosubmit/database \
    -v ${YOUR_EXPERIMENTS_PATH}:/app/autosubmit/experiments \
    -e "PROTECTION_LEVEL=NONE" \  # This will disable protection
    autosubmit-api start -w=6 --log-level=DEBUG -b=0.0.0.0:9000
```